<script lang="ts">
	import { createEventDispatcher } from 'svelte'
	interface Props {
		accentColour?: string;
		text?: string;
		addState?: boolean;
	}

	let { accentColour = '#d891ff', text = '', addState = false }: Props = $props();
	let typing = $state(false)
	let textElement: HTMLSpanElement = $state()

	const dispatch = createEventDispatcher()

	function clicked() {
		dispatch('click', { text: textElement.innerText })
		textElement.innerText = ''
	}

	function focusLost() {
		typing = false
		clicked()
	}

	function focusMe() {
		typing = true
		textElement.focus()
	}
</script>

{#if addState}
	<div
		class={typing ? 'hasFocus' : ''}
		onclick={focusMe}
		onkeypress={focusMe}
		style="--accentColour:{accentColour + '99'}; color:{accentColour};
    border-color:{accentColour + '77'}"
	>
		<span
			style="color:{accentColour}"
			bind:this={textElement}
			class="textarea"
			role="textbox"
			onfocusout={focusLost}
			contenteditable
		></span>
		<span style="color:{accentColour}" onclick={clicked} onkeypress={clicked}> &nbsp; ＋ </span>
	</div>
{:else}
	<div role="button" tabindex="0" style="color:{accentColour}" onclick={clicked} onkeypress={clicked}>
		<span bind:this={textElement}>{text}</span>
		<span>&nbsp; ✕</span>
	</div>
{/if}

<style>
	div {
		display: inline-block;
		background-color: rgba(0, 0, 0, 0.25);
		border-radius: 40px;
		padding-left: 20px;
		padding-right: 15px;
		padding-top: 10px;
		padding-bottom: 10px;
		margin: 10px;
		margin-left: 0px;
		font-weight: 700;
		font-size: 14px;
		height: 18px;
		user-select: none;
	}

	.hasFocus {
		padding-top: 9px;
		padding-bottom: 9px;
		border-style: solid;
		border-width: 1px;
	}

	span {
		background-color: transparent;
		border: none;
		color: var(--accentColour);
		font-size: 0.9em;
		font-weight: 700;
	}

	.textarea[contenteditable]:empty::before {
		content: 'new item';
		color: var(--accentColour);
	}

	span:focus {
		border: none;
		outline: none;
	}
</style>
